// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __C_SHARED_OBJECT_WIN32_H_INCLUDED__
#define __C_SHARED_OBJECT_WIN32_H_INCLUDED__


#include "IrrCompileConfig.h"

#if defined(_IRR_COMPILE_WITH_WINDOWS_DEVICE_)

#include "path.h"

#include "ISharedObject.h"
#include <windows.h>


namespace irr {

//template<class T>
class CSharedObjectWin32 : public ISharedObject
{

public:
    CSharedObjectWin32();
    ~CSharedObjectWin32();

    virtual bool load( io::path filename) ;
    virtual void * getSymbol(const core::stringc& name) ;


protected:

    //----------------------------------------------------------
    // Types
    //----------------------------------------------------------
//    typedef T* (*PtrFunc)();D:\libsCpp\irrWindow2\examples\01.HelloWorld\HelloWorld.cbp

    HMODULE m_Library; // Handle de la DLL
};


}

#endif

#endif
