
// Copyright (C) 2002-2011 Matthieu Coudron
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __C_PLUGIN_LOADER_H_INCLUDED__
#define __C_PLUGIN_LOADER_H_INCLUDED__

#include "path.h"
#include "irrCompileConfig.h"
#include <windows.h>


typedef void (*DLL_START_PLUGIN)(void);
typedef void (*DLL_STOP_PLUGIN)(void);



template<class T>
class CPluginLoader
{

public:
    CPluginLoader();
    ~CPluginLoader();

    T* load(const io::path& filename);

protected:

    //----------------------------------------------------------
    // Types
    //----------------------------------------------------------
    typedef T* (*PtrFunc)();

    HMODULE m_Library; // Handle de la DLL
};


#if defined(_IRR_COMPILE_WITH_WINDOWS_DEVICE_)

template <class T>
inline T* CPluginLoader<T>::Load(const io::path& Filename)
{

    //! we should add correct extension according to platform core::stringc

    // Chargement de la bibliothèque dynamique
    m_Library = LoadLibrary( Filename.c_str() );
    if (!m_Library)
    {
        os::Printer::log("Can't load library",ELL_ERROR);
    }


    // Récupération de la fonction
    PtrFunc Function = reinterpret_cast<PtrFunc>(GetProcAddress(m_Library, "StartPlugin"));
    if (!Function)
        os::Logger::log("Can't find function 'StartPlugin'");

    return Function();
}

#elif

#endif
