#include "IrrCompileConfig.h"



#ifdef _IRR_COMPILE_WITH_WINDOWS_DEVICE_
#ifdef _IRR_COMPILE_WITH_BURNINGSVIDEO_


#include "IRenderWindow.h"
#include "CRenderWindowWin32.h"
#include "CBurningVideoContextWin32.h"
#include "CImage.h"
#include "IDepthBuffer.h"

namespace irr
{
namespace video
{
CBurningVideoContextWin32::CBurningVideoContextWin32(
                        HWND windowHandle,
                        IDepthBuffer* depthBuffer,
                        CImage* backBuffer,
                        IStencilBuffer* stencilBuffer,
                        const SVideoContextConfig& config
                        ) :
    IBurningVideoContext(depthBuffer,backBuffer,stencilBuffer,config)
    , ISoftwareContextWin32( GetDC(windowHandle) )
//    , WindowHandle(windowHandle)
{
    //!
//    setTarget(windowHandle)
}



CBurningVideoContextWin32::~CBurningVideoContextWin32()
{

}


bool CBurningVideoContextWin32::isCompatibleWithRenderWindow(IRenderWindow* ) const
{
    return true;
}





bool CBurningVideoContextWin32::setTarget(void* data )
{
    return ISoftwareContextWin32::setDeviceContext( (HDC)data );
}


bool CBurningVideoContextWin32::swapBuffers(core::rect<s32>* src)
{
    return ISoftwareContextWin32::displayImage( BackBuffer, src );
//    return false;
}


void CBurningVideoContextWin32::releaseContext()
{

//    delete BackBuffer;
}



} // video
} // irr

#endif // _IRR_COMPILE_WITH_BURNINGSVIDEO_
#endif // _IRR_COMPILE_WITH_WINDOWS_DEVICE_
