

// Copyright (C) 2002-2011 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __I_SOFTWARE_CONTEXT_LINUX_H_INCLUDED__
#define __I_SOFTWARE_CONTEXT_LINUX_H_INCLUDED__


#include "IrrCompileConfig.h"

#ifdef _IRR_COMPILE_WITH_X11_DEVICE_

#include "IVideoContext.h"
#include "ISoftwareContext.h"
#include "CRenderWindowLinux.h"
#include <X11/Xlib.h>


namespace irr
{
namespace video
{

class IRenderWindow;
class CImage;
class IZBuffer;
class IStencilBuffer ;

// IWin32 presenter
class ISoftwareContextLinux
{
public:


    ISoftwareContextLinux(XImage* image);
    virtual ~ISoftwareContextLinux();

    virtual bool setTarget(const SRenderWindowLinuxHandle& ) ;

    virtual bool swapBuffers(IImage* image, core::rect<s32>* src) ;
    virtual void releaseContext();

private:
    XImage* SoftwareImage;
    SRenderWindowLinuxHandle VideoData;
};

}   // video
}   // irr

#endif // _IRR_COMPILE_WITH_X11_DEVICE_

#endif
